"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fullObjectPath = exports.lastObjectProperty = exports.i18ObjectPath = exports.getPath = exports.createProxy = void 0;
var pathSymbol = Symbol("Proxy object path");
var createProxy = function (path) {
    var _a;
    if (path === void 0) { path = []; }
    return new Proxy((_a = {},
        _a[pathSymbol] = path,
        _a), {
        get: function (target, key) {
            if (key === pathSymbol) {
                return target[pathSymbol];
            }
            return exports.createProxy(__spreadArrays((path || []), [key]));
        }
    });
};
exports.createProxy = createProxy;
var getPath = function (proxy) {
    if (!proxy)
        return [];
    return proxy[pathSymbol];
};
exports.getPath = getPath;
var i18ObjectPath = function (proxy) {
    var path = exports.getPath(proxy);
    if (!(path === null || path === void 0 ? void 0 : path.length))
        return "";
    if (path.length === 1)
        return path[0].toString();
    return path[0].toString() + ":" + path.slice(1).join(".");
};
exports.i18ObjectPath = i18ObjectPath;
var lastObjectProperty = function (proxy) {
    var path = exports.getPath(proxy);
    if (!(path === null || path === void 0 ? void 0 : path.length))
        return "";
    return path[path.length - 1];
};
exports.lastObjectProperty = lastObjectProperty;
var fullObjectPath = function (proxy) {
    var path = exports.getPath(proxy);
    if (!(path === null || path === void 0 ? void 0 : path.length))
        return "";
    return path.join(".");
};
exports.fullObjectPath = fullObjectPath;
